import random
from .MachineAssignment import MachineAssignment
from .OperationAssignment import OperationAssignment


def initial_solution(data, data2, overview, job_n):
    """
    Initial solution
    :param data:
    :param data2:
    :param overview:
    :param job_n:
    :return:
    """
    u = random.random()
    if u < 0.1:
        MA = MachineAssignment(data, data2, overview, job_n, shuffle=False)
        mach = MA.localization()
    else:
        MA = MachineAssignment(data, data2, overview, job_n, shuffle=True)
        mach = MA.localization()

    u = random.random()

    if u < 0.2:
        SE = OperationAssignment(data, data2, mach, overview, job_n)
        seq = SE.random()
    elif 0.6 > u >= 0.2:
        SE = OperationAssignment(data, data2, mach, overview, job_n)
        seq = SE.mwr()
    elif 1 > u >= 0.6:
        SE = OperationAssignment(data, data2, mach, overview, job_n)
        seq = SE.mor()

    return [seq, mach]

