from operator import attrgetter
import random


def Tournament(individuals, k, tournsize, fit_attr="fitness"):
    """Select the best individual among *tournsize* randomly chosen
    individuals, *k* times. The list returned contains
    references to the input *individuals*.
    """
    chosen = []
    for i in range(k):
        aspirants = [random.choice(individuals) for j in range(tournsize)] #selRandom(individuals, tournsize)
        chosen.append(min(aspirants, key=attrgetter(fit_attr)))
    return chosen
